/******************************************************************************

	inptport.c

	CPS2 ݣȫ߫죭

******************************************************************************/

#include "cps2.h"


/******************************************************************************
	Ыܨ
******************************************************************************/

#ifdef GP2X

#define        GPX_VK_UP                  (1<<0)        
#define        GPX_VK_UP_LEFT             (1<<1)        
#define        GPX_VK_LEFT                (1<<2)        
#define        GPX_VK_DOWN_LEFT           (1<<3)        
#define        GPX_VK_DOWN                (1<<4)        
#define        GPX_VK_DOWN_RIGHT          (1<<5)        
#define        GPX_VK_RIGHT               (1<<6)        
#define        GPX_VK_UP_RIGHT            (1<<7)        

#define        GPX_VK_START               (1<<8)        
#define        GPX_VK_SELECT              (1<<9)        
#define        GPX_VK_FL                  (1<<10)        
#define        GPX_VK_FR                  (1<<11)        
#define        GPX_VK_FA                  (1<<12)        
#define        GPX_VK_FB                  (1<<13)        
#define        GPX_VK_FX                  (1<<14)        
#define        GPX_VK_FY                  (1<<15)        

#define        GPX_VK_VOL_UP              (1<<16)        
#define        GPX_VK_VOL_DOWN            (1<<17)        
#define        GPX_VK_TAT                 (1<<18)

extern int joy_fd;

#endif

int option_controller;
u16 cps2_port_value[CPS2_PORT_MAX];

int input_map[MAX_INPUTS];
int input_max_players;
int input_max_buttons;
int input_coin_chuter;
int analog_sensitivity;
int af_interval = 1;


/******************************************************************************
	ܨ
******************************************************************************/

u8 ALIGN_DATA input_flag[MAX_INPUTS];
static int ALIGN_DATA af_map1[CPS2_BUTTON_MAX];
static int ALIGN_DATA af_map2[CPS2_BUTTON_MAX];
static int ALIGN_DATA af_flag[CPS2_BUTTON_MAX];
static int ALIGN_DATA af_counter[CPS2_BUTTON_MAX];
static int input_analog_value[2];
static int input_ui_wait;
static int service_switch;
static int p12_start_pressed;

static u8 max_players[COIN_MAX] =
{
	2,	// COIN_NONE: 2P 2壭ͳ (ë驪ʪ)

	2,	// COIN_2P1C: 2P 1壭
	2,	// COIN_2P2C: 2P 2壭

	3,	// COIN_3P1C: 3P 1壭
	3,	// COIN_3P2C: 3P 2壭
	3,	// COIN_3P3C: 3P 3壭

	4,	// COIN_4P1C: 4P 1壭
	4,	// COIN_4P2C: 4P 2壭
	4	// COIN_4P4C: 4P 4壭
};

static u8 coin_chuter[COIN_MAX][4] =
{
	{ 1, 2, 0, 0 },	// COIN_NONE: 2P 2壭ͳ (ë驪ʪ)

	{ 1, 1, 0, 0 },	// COIN_2P1C: 2P 1壭
	{ 1, 2, 0, 0 },	// COIN_2P2C: 2P 2壭

	{ 1, 1, 1, 0 },	// COIN_3P1C: 3P 1壭
	{ 1, 1, 2, 0 },	// COIN_3P2C: 3P 2壭
	{ 1, 2, 3, 0 },	// COIN_3P3C: 3P 3壭

	{ 1, 1, 1, 1 },	// COIN_4P1C: 4P 1壭
	{ 1, 1, 2, 2 },	// COIN_3P2C: 4P 2壭
	{ 1, 2, 3, 4 }	// COIN_3P3C: 4P 4壭
};


/******************************************************************************
	μ
******************************************************************************/

/*------------------------------------------------------
	EEPROMΫҪë
------------------------------------------------------*/

static void check_eeprom_settings(int popup)
{
	u8 eeprom_value = EEPROM_read_data(driver->inp_eeprom);
	u8 coin_type = driver->inp_eeprom_value[eeprom_value];

	if (input_coin_chuter != coin_type)
	{
		input_coin_chuter = coin_type;
		input_max_players = max_players[coin_type];

		if (option_controller >= input_max_players)
		{
			option_controller = INPUT_PLAYER1;
			if (popup) ui_popup("Controller: Player 1");
		}
	}
}


/*------------------------------------------------------
	֧ҫի髰
------------------------------------------------------*/

static u32 update_autofire(u32 buttons)
{
	int i;

	for (i = 0; i < input_max_buttons; i++)
	{
		if (af_map1[i])
		{
			if (buttons & af_map1[i])
			{
				buttons &= ~af_map1[i];

				af_counter[i]++;

				if (af_counter[i] >= af_interval)
				{
					af_counter[i] = 0;
					af_flag[i] ^= 1;
				}

				if (af_flag[i])
					buttons &= ~af_map2[i];
				else
					buttons |= af_map2[i];
			}
			else
			{
				af_counter[i] = 0;
				af_flag[i] = 0;
			}
		}
	}

	return buttons;
}


/*------------------------------------------------------
	CPS2 ݣ0 (ȫ1 / 2)
------------------------------------------------------*/

static void update_inputport0(void)
{
	u16 value = 0xffff;

	switch (machine_input_type)
	{
	case INPTYPE_19xx:
	case INPTYPE_batcir:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0100;
			if (input_flag[P1_LEFT])    value &= ~0x0200;
			if (input_flag[P1_DOWN])    value &= ~0x0400;
			if (input_flag[P1_UP])      value &= ~0x0800;
			if (input_flag[P1_BUTTON1]) value &= ~0x1000;
			if (input_flag[P1_BUTTON2]) value &= ~0x2000;
		}
		break;

	case INPTYPE_cps2:
	case INPTYPE_cybots:
	case INPTYPE_ssf2:
	case INPTYPE_avsp:
	case INPTYPE_sgemf:
	case INPTYPE_daimahoo:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
			if (input_flag[P1_BUTTON3]) value &= ~0x0040;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0100;
			if (input_flag[P1_LEFT])    value &= ~0x0200;
			if (input_flag[P1_DOWN])    value &= ~0x0400;
			if (input_flag[P1_UP])      value &= ~0x0800;
			if (input_flag[P1_BUTTON1]) value &= ~0x1000;
			if (input_flag[P1_BUTTON2]) value &= ~0x2000;
			if (input_flag[P1_BUTTON3]) value &= ~0x4000;
		}
		break;

	case INPTYPE_ddtod:
	case INPTYPE_puzloop2:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
			if (input_flag[P1_BUTTON3]) value &= ~0x0040;
			if (input_flag[P1_BUTTON4]) value &= ~0x0080;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0100;
			if (input_flag[P1_LEFT])    value &= ~0x0200;
			if (input_flag[P1_DOWN])    value &= ~0x0400;
			if (input_flag[P1_UP])      value &= ~0x0800;
			if (input_flag[P1_BUTTON1]) value &= ~0x1000;
			if (input_flag[P1_BUTTON2]) value &= ~0x2000;
			if (input_flag[P1_BUTTON3]) value &= ~0x4000;
			if (input_flag[P1_BUTTON4]) value &= ~0x8000;
		}
		break;

	case INPTYPE_qndream:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0001;
			if (input_flag[P1_BUTTON3]) value &= ~0x0002;
			if (input_flag[P1_BUTTON2]) value &= ~0x0004;
			if (input_flag[P1_BUTTON1]) value &= ~0x0008;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0100;
			if (input_flag[P1_BUTTON3]) value &= ~0x0200;
			if (input_flag[P1_BUTTON2]) value &= ~0x0400;
			if (input_flag[P1_BUTTON1]) value &= ~0x0800;
		}
		break;
	}

	cps2_port_value[0] = value;
}


/*------------------------------------------------------
	CPS2 ݣ1 (ȫ3 / 4 / ʥܫ)
------------------------------------------------------*/

static void update_inputport1(void)
{
	u16 value = 0xffff;

	switch (machine_input_type)
	{
	case INPTYPE_cybots:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0001;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0100;
		}
		break;

	case INPTYPE_cps2:
	case INPTYPE_ssf2:
		if (option_controller == INPUT_PLAYER1)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0001;
			if (input_flag[P1_BUTTON5]) value &= ~0x0002;
			if (input_flag[P1_BUTTON6]) value &= ~0x0004;
		}
		else if (option_controller == INPUT_PLAYER2)
		{
			if (input_flag[P1_BUTTON4]) value &= ~0x0100;
			if (input_flag[P1_BUTTON5]) value &= ~0x0200;
		}
		break;

	case INPTYPE_batcir:
		if (option_controller == INPUT_PLAYER3)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
		}
		else if (option_controller == INPUT_PLAYER4)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0100;
			if (input_flag[P1_LEFT])    value &= ~0x0200;
			if (input_flag[P1_DOWN])    value &= ~0x0400;
			if (input_flag[P1_UP])      value &= ~0x0800;
			if (input_flag[P1_BUTTON1]) value &= ~0x1000;
			if (input_flag[P1_BUTTON2]) value &= ~0x2000;
		}
		break;

	case INPTYPE_avsp:
		if (option_controller == INPUT_PLAYER3)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
			if (input_flag[P1_BUTTON3]) value &= ~0x0040;
		}
		break;

	case INPTYPE_ddtod:
		if (option_controller == INPUT_PLAYER3)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0001;
			if (input_flag[P1_LEFT])    value &= ~0x0002;
			if (input_flag[P1_DOWN])    value &= ~0x0004;
			if (input_flag[P1_UP])      value &= ~0x0008;
			if (input_flag[P1_BUTTON1]) value &= ~0x0010;
			if (input_flag[P1_BUTTON2]) value &= ~0x0020;
			if (input_flag[P1_BUTTON3]) value &= ~0x0040;
			if (input_flag[P1_BUTTON4]) value &= ~0x0080;
		}
		else if (option_controller == INPUT_PLAYER4)
		{
			if (input_flag[P1_RIGHT])   value &= ~0x0100;
			if (input_flag[P1_LEFT])    value &= ~0x0200;
			if (input_flag[P1_DOWN])    value &= ~0x0400;
			if (input_flag[P1_UP])      value &= ~0x0800;
			if (input_flag[P1_BUTTON1]) value &= ~0x1000;
			if (input_flag[P1_BUTTON2]) value &= ~0x2000;
			if (input_flag[P1_BUTTON3]) value &= ~0x4000;
			if (input_flag[P1_BUTTON4]) value &= ~0x8000;
		}
		break;
	}

	cps2_port_value[1] = value;
}


/*------------------------------------------------------
	CPS2 ݣ2 (START / COIN)
------------------------------------------------------*/

static void update_inputport2(void)
{
	u16 value = 0xffff;

	if (input_flag[SERV_SWITCH] || service_switch)
	{
		value &= ~0x0002;
	}
	if (input_flag[SERV_COIN])
	{
		value &= ~0x0004;
	}
	if (p12_start_pressed)
	{
		value &= ~(0x0100 | 0x0200);
	}

	if (input_flag[P1_COIN])
	{
		switch (coin_chuter[input_coin_chuter][option_controller])
		{
		case 1: value &= ~0x1000; break;
		case 2: value &= ~0x2000; break;
		case 3: value &= ~0x4000; break;
		case 4: value &= ~0x8000; break;
		}
	}

	if (option_controller == INPUT_PLAYER1)
	{
		if (input_flag[P1_START]) value &= ~0x0100;
		if (input_flag[P2_START]) value &= ~0x0200;
	}
	else if (option_controller == INPUT_PLAYER2)
	{
		if (input_flag[P1_START]) value &= ~0x0200;
		if (input_flag[P2_START]) value &= ~0x0100;
	}

	switch (machine_input_type)
	{
	case INPTYPE_cps2:
	case INPTYPE_ssf2:
		if (option_controller == INPUT_PLAYER2)
		{
			// Player 2 button 6
			if (input_flag[P1_BUTTON6]) value &= ~0x4000;
		}
		break;

	case INPTYPE_avsp:
		if (option_controller == INPUT_PLAYER3)
		{
			// Player 3 start
			if (input_flag[P1_START]) value &= ~0x0400;
		}
		break;

	case INPTYPE_ddtod:
	case INPTYPE_batcir:
		if (option_controller == INPUT_PLAYER3)
		{
			// Player 3 start
			if (input_flag[P1_START]) value &= ~0x0400;
		}
		else if (option_controller == INPUT_PLAYER4)
		{
			// Player 4 start
			if (input_flag[P1_START]) value &= ~0x0800;
		}
		break;
	}

	cps2_port_value[2] = value;
}


/*------------------------------------------------------
	puzloop2 ʫݣ
------------------------------------------------------*/

static void update_inputport3(void)
{
	int delta = 0;

	if (input_flag[P1_DIAL_L])
	{
		switch (analog_sensitivity)
		{
		case 0: delta -= 10; break;
		case 1: delta -= 15; break;
		case 2: delta -= 20; break;
		}
	}
	if (input_flag[P1_DIAL_R])
	{
		switch (analog_sensitivity)
		{
		case 0: delta += 10; break;
		case 1: delta += 15; break;
		case 2: delta += 20; break;
		}
	}
	input_analog_value[option_controller] = (input_analog_value[option_controller] + delta) & 0xff;

	cps2_port_value[3] = input_analog_value[0] | (input_analog_value[1] << 8);
}


/*------------------------------------------------------
	ܫ۰請
------------------------------------------------------*/

static u32 adjust_input(u32 buttons)
{
#ifdef GP2X
	u32 buttons2;
	
	if (buttons & (GPX_VK_UP | GPX_VK_DOWN | GPX_VK_LEFT | GPX_VK_RIGHT))
        buttons &= ~(GPX_VK_UP_LEFT | GPX_VK_UP_RIGHT | GPX_VK_DOWN_LEFT | GPX_VK_DOWN_RIGHT);
    if (buttons & GPX_VK_UP_LEFT) buttons |= GPX_VK_UP | GPX_VK_LEFT;
    if (buttons & GPX_VK_UP_RIGHT) buttons |= GPX_VK_UP | GPX_VK_RIGHT;
    if (buttons & GPX_VK_DOWN_LEFT) buttons |= GPX_VK_DOWN | GPX_VK_LEFT;
    if (buttons & GPX_VK_DOWN_RIGHT) buttons |= GPX_VK_DOWN | GPX_VK_RIGHT;

	if (!cps_flip_screen && machine_screen_type != SCREEN_VERTICAL)
		return buttons;

	if (!machine_screen_type)
	{
		if (cps_flip_screen)
		{
			buttons2 = buttons & (GPX_VK_START | GPX_VK_SELECT);

			if (buttons & GPX_VK_UP)     buttons2 |= GPX_VK_DOWN;
			if (buttons & GPX_VK_DOWN)   buttons2 |= GPX_VK_UP;
			if (buttons & GPX_VK_RIGHT)  buttons2 |= GPX_VK_LEFT;
			if (buttons & GPX_VK_LEFT)   buttons2 |= GPX_VK_RIGHT;
			if (buttons & GPX_VK_FA)     buttons2 |= GPX_VK_FB;
			if (buttons & GPX_VK_FB)     buttons2 |= GPX_VK_FA;
			if (buttons & GPX_VK_FY)     buttons2 |= GPX_VK_FX;
			if (buttons & GPX_VK_FX)     buttons2 |= GPX_VK_FY;
			if (buttons & GPX_VK_FR)     buttons2 |= GPX_VK_FL;
			if (buttons & GPX_VK_FL)     buttons2 |= GPX_VK_FR;

			buttons = buttons2;
		}
	}
	else
	{
		if (!cps_rotate_screen)
		{
			buttons2 = buttons & (GPX_VK_START | GPX_VK_SELECT | GPX_VK_FR | GPX_VK_FL);

			if (buttons & GPX_VK_UP)       buttons2 |= GPX_VK_LEFT;
			if (buttons & GPX_VK_DOWN)     buttons2 |= GPX_VK_RIGHT;
			if (buttons & GPX_VK_RIGHT)    buttons2 |= GPX_VK_UP;
			if (buttons & GPX_VK_LEFT)     buttons2 |= GPX_VK_DOWN;
			if (buttons & GPX_VK_VOL_DOWN) buttons2 |= GPX_VK_FA;
			if (buttons & GPX_VK_VOL_UP)   buttons2 |= GPX_VK_FB;
			if (buttons & GPX_VK_FL)       buttons2 |= GPX_VK_FX;
			if (buttons & GPX_VK_FR)       buttons2 |= GPX_VK_FY;
			if (buttons & GPX_VK_FA)       buttons2 |= GPX_VK_FL;
			if (buttons & GPX_VK_FB)       buttons2 |= GPX_VK_FR;

			buttons = buttons2;
		}

		if (cps_flip_screen)
		{
			buttons2 = buttons & (GPX_VK_START | GPX_VK_SELECT);

			if (buttons & GPX_VK_UP)     buttons2 |= GPX_VK_DOWN;
			if (buttons & GPX_VK_DOWN)   buttons2 |= GPX_VK_UP;
			if (buttons & GPX_VK_RIGHT)  buttons2 |= GPX_VK_LEFT;
			if (buttons & GPX_VK_LEFT)   buttons2 |= GPX_VK_RIGHT;
			if (buttons & GPX_VK_FA)     buttons2 |= GPX_VK_FB;
			if (buttons & GPX_VK_FB)     buttons2 |= GPX_VK_FA;
			if (buttons & GPX_VK_FY)     buttons2 |= GPX_VK_FX;
			if (buttons & GPX_VK_FX)     buttons2 |= GPX_VK_FY;
			if (buttons & GPX_VK_FR)     buttons2 |= GPX_VK_FL;
			if (buttons & GPX_VK_FL)     buttons2 |= GPX_VK_FR;

			buttons = buttons2;
		}
	}
#endif
	return buttons;
}


/******************************************************************************
	ݣȫ󫿫իμ
******************************************************************************/

/*------------------------------------------------------
	ݣȪѢ
------------------------------------------------------*/

void input_init(void)
{
	input_ui_wait = 0;
	service_switch = 0;
	p12_start_pressed = 0;

	memset(cps2_port_value, 0xff, sizeof(cps2_port_value));

	memset(af_flag, 0, sizeof(af_flag));
	memset(af_counter, 0, sizeof(af_counter));

	memset(input_flag, 0, sizeof(input_flag));

	input_analog_value[0] = 0;
	input_analog_value[1] = 0;

	switch (machine_input_type)
	{
	case INPTYPE_avsp:
		input_max_players = 3;
		break;

	case INPTYPE_ddtod:
	case INPTYPE_batcir:
		input_max_players = 4;
		break;

	default:
		input_max_players = 2;
		break;
	}

	switch (machine_input_type)
	{
	case INPTYPE_19xx:
	case INPTYPE_batcir:
		input_max_buttons = 2;
		break;

	case INPTYPE_cybots:
	case INPTYPE_ddtod:
	case INPTYPE_qndream:
	case INPTYPE_puzloop2:
		input_max_buttons = 4;
		break;

	case INPTYPE_cps2:
	case INPTYPE_ssf2:
		input_max_buttons = 6;
		break;

	default:
		input_max_buttons = 3;
		break;
	}

	input_coin_chuter = COIN_NONE;
}


/*------------------------------------------------------
	ݣȪ
------------------------------------------------------*/

void input_shutdown(void)
{
}


/*------------------------------------------------------
	ݣȪ꫻ë
------------------------------------------------------*/

void input_reset(void)
{
	memset(cps2_port_value, 0xff, sizeof(cps2_port_value));
	input_analog_value[0] = 0;
	input_analog_value[1] = 0;
	service_switch = 0;
	p12_start_pressed = 0;

#ifdef GP2X
	memset(input_map, 0, sizeof(input_map));

	input_map[P1_RIGHT] = GPX_VK_RIGHT;
	input_map[P1_LEFT] = GPX_VK_LEFT;
	input_map[P1_DOWN] = GPX_VK_DOWN;
	input_map[P1_UP] = GPX_VK_UP;

	input_map[P1_BUTTON1] = GPX_VK_FA;
	input_map[P1_BUTTON2] = GPX_VK_FB;
	input_map[P1_BUTTON3] = GPX_VK_FX;
	input_map[P1_BUTTON4] = GPX_VK_FY;
	input_map[P1_BUTTON5] = GPX_VK_FL;
	input_map[P1_BUTTON6] = GPX_VK_FR;

	input_map[P1_START] = GPX_VK_START;
	input_map[P1_COIN] = GPX_VK_SELECT;
#endif

	setup_autofire();

	if (driver->inp_eeprom) check_eeprom_settings(0);
}


/*------------------------------------------------------
	֧ҫի髰
------------------------------------------------------*/

void setup_autofire(void)
{
	int i;

	for (i = 0; i < CPS2_BUTTON_MAX; i++)
	{
		af_map1[i] = input_map[P1_AF_1 + i];
		af_map2[i] = input_map[P1_BUTTON1 + i];
	}
}


/*------------------------------------------------------
	ݣȪ
------------------------------------------------------*/

void update_inputport(void)
{
	int i;
	u32 buttons;

	service_switch = 0;
	p12_start_pressed = 0;

	if (driver->inp_eeprom) check_eeprom_settings(1);
/*
	buttons = poll_gamepad();

	if ((buttons & GPX_VK_START) && (buttons & GPX_VK_SELECT))
	{
		buttons &= ~(GPX_VK_START | GPX_VK_SELECT);

		showmenu();
		setup_autofire();
	}

	if ((buttons & GPX_VK_FL) && (buttons & GPX_VK_FR))
	{
		if (buttons & GPX_VK_SELECT)
		{
			buttons &= ~(GPX_VK_SELECT | GPX_VK_FL | GPX_VK_FR);
			service_switch = 1;
		}
		else if (buttons & GPX_VK_START)
		{
			buttons &= ~(GPX_VK_START | GPX_VK_FL | GPX_VK_FR);
			p12_start_pressed = 1;
		}
	}

	buttons = update_autofire(buttons);

	for (i = 0; i < MAX_INPUTS; i++)
		input_flag[i] = (buttons & input_map[i]) != 0;
*/
#ifdef GP2X
    if((joy_fd < 0) || (read(joy_fd, &buttons, 4) != 4)) {
        buttons = 0;
    } else {
    	static u32 prev = 0;
        u32 change = prev ^ buttons;

    	if ((buttons & (GPX_VK_START | GPX_VK_SELECT)) && (buttons & GPX_VK_FL) && (buttons & GPX_VK_FR))
            Loop = LOOP_EXIT;
            
        if ((machine_screen_type != SCREEN_VERTICAL) || (buttons & (GPX_VK_START | GPX_VK_SELECT))) {
            if (buttons & change & GPX_VK_VOL_UP) {
                if (buttons & GPX_VK_SELECT) {
                    if(option_autoframeskip) {
                        option_autoframeskip = 0;
                        option_frameskip = 0;
                        autoframeskip_reset();
                        msg_printf("Frame Skip: %d\n", option_frameskip);
                    } else if(option_frameskip < 11) {
                        ++option_frameskip;
                        msg_printf("Frame Skip: %d\n", option_frameskip);
                    }
                } else {
                    if(option_sound_volume < 30)
                        sound_volume(option_sound_volume + 2);
                    else
                        sound_volume(option_sound_volume + 5);
                }
            }
    
            if (buttons & change & GPX_VK_VOL_DOWN) {
                if (buttons & GPX_VK_SELECT) {
                    option_autoframeskip = 0;
                    if(option_frameskip > 0) {
                        --option_frameskip;
                        msg_printf("Frame Skip: %d\n", option_frameskip);
                    } else {
                        option_autoframeskip = 1;
                        autoframeskip_reset();
                        msg_printf("Frame Skip: Auto\n");
                    }
                } else {
                    if(option_sound_volume > 30)
                        sound_volume(option_sound_volume - 5);
                    else
                        sound_volume(option_sound_volume - 2);
                }
            }
        }

    	prev = buttons;
    
    	buttons = adjust_input(buttons);
    }

	for (i = 0; i < MAX_INPUTS; i++)
		input_flag[i] = (buttons & input_map[i]) != 0;
#endif

	update_inputport0();
	update_inputport1();
	update_inputport2();
	if (machine_input_type == INPTYPE_puzloop2) update_inputport3();

	if (input_flag[SNAPSHOT])
	{
		save_snapshot();
	}
	if (input_flag[SWPLAYER])
	{
		if (!input_ui_wait)
		{
			option_controller++;
			if (option_controller == input_max_players)
				option_controller = INPUT_PLAYER1;
			ui_popup("Controller: Player %d", option_controller + 1);
			input_ui_wait = 30;
		}
	}
	if (input_ui_wait > 0) input_ui_wait--;
}


/******************************************************************************
	/ ƣ
******************************************************************************/

#ifdef SAVE_STATE

STATE_SAVE( input )
{
	state_save_long(&option_controller, 1);
	state_save_long(&input_analog_value[0], 1);
	state_save_long(&input_analog_value[1], 1);
}

STATE_LOAD( input )
{
	state_load_long(&option_controller, 1);
	state_load_long(&input_analog_value[0], 1);
	state_load_long(&input_analog_value[1], 1);

	setup_autofire();
	input_ui_wait = 0;
	p12_start_pressed = 0;
	service_switch = 0;
}

#endif /* SAVE_STATE */
