/******************************************************************************

	sprite.c

	CPS2 ׫髤ȫޫͣ

******************************************************************************/

#include "cps2.h"
#include <SDL.h>

/******************************************************************************
	/ޫ
******************************************************************************/

extern SDL_Surface *work_frame;
extern SPRITE sprite_info[MAX_SPRITE];
extern int sprite_count;

/******************************************************************************
	ܨ/ϰ
******************************************************************************/

static int clip_min_y;
static int clip_max_y;

static int onject_min_y;
static int scroll2_min_y;
static int scroll2_max_y;

/*------------------------------------------------------------------------
	׫髤Ϋ꫻ë
------------------------------------------------------------------------*/

void blit_reset(void)
{
	clip_min_y = FIRST_VISIBLE_LINE;
	clip_max_y = LAST_VISIBLE_LINE;
}


/*------------------------------------------------------------------------
	׫髤
------------------------------------------------------------------------*/
/*
static void blit_start(void)
{
}
*/

/*------------------------------------------------------------------------
	ݻ
------------------------------------------------------------------------*/

void blit_partial_start(int start, int end)
{
	clip_min_y  = start;
	clip_max_y  = end + 1;

	onject_min_y = start - 16;
	
	sprite_count = 0;
/*
	if (start == FIRST_VISIBLE_LINE)
		blit_start();
*/
}


/*------------------------------------------------------------------------
	׫髤
------------------------------------------------------------------------*/

void blit_finish(void)
{
    sprite_info[sprite_count].type = SPRITE_END;
    sprite_info[sprite_count].src = 0;
    sprite_info[sprite_count].dst = 0;
    sprite_info[sprite_count].color = 0;
    sprite_info[sprite_count].attr = 0;
}


/*------------------------------------------------------------------------
	OBJECT꫹Ȫ
------------------------------------------------------------------------*/

void blit_draw_object(int x, int y, int z, u32 code, u32 attr)
{
	if ((x > 48 && x < 448) && (y > onject_min_y && y < clip_max_y))
	{
        sprite_info[sprite_count].type = SPRITE_16;
		sprite_info[sprite_count].src = (*read_cache)(code << 7);
		sprite_info[sprite_count].dst = x + BUF_WIDTH * y;
		sprite_info[sprite_count].color = attr & 0x1f;
		sprite_info[sprite_count].attr = attr & 0x60;
		++sprite_count;
	}
}


/*------------------------------------------------------------------------
	SCROLL1꫹Ȫ
------------------------------------------------------------------------*/

void blit_draw_scroll1(int x, int y, u32 code, u32 attr)
{
    sprite_info[sprite_count].type = SPRITE_8;
	sprite_info[sprite_count].src = (*read_cache)(code << 6);
	sprite_info[sprite_count].dst = x + BUF_WIDTH * y;
	sprite_info[sprite_count].color = (attr & 0x1f) + 32;
	sprite_info[sprite_count].attr = attr & 0x60;
	++sprite_count;
}


/*------------------------------------------------------------------------
	SCROLL2ƫ
------------------------------------------------------------------------*/

void blit_set_clip_scroll2(int min_y, int max_y)
{
	scroll2_min_y = min_y;
	scroll2_max_y = max_y + 1;
}


/*------------------------------------------------------------------------
	SCROLL2꫹Ȫ
------------------------------------------------------------------------*/

void blit_draw_scroll2(int x, int y, u32 code, u32 attr)
{
	if (y > scroll2_min_y - 16 && y < scroll2_max_y)
	{
        sprite_info[sprite_count].type = SPRITE_16;
		sprite_info[sprite_count].src = (*read_cache)(code << 7);
		sprite_info[sprite_count].dst = x + BUF_WIDTH * y;
		sprite_info[sprite_count].color = (attr & 0x1f) + 64;
		sprite_info[sprite_count].attr = attr & 0x60;
		++sprite_count;
	}
}


/*------------------------------------------------------------------------
	SCROLL3꫹Ȫ
------------------------------------------------------------------------*/

void blit_draw_scroll3(int x, int y, u32 code, u32 attr)
{
    sprite_info[sprite_count].type = SPRITE_32;
	sprite_info[sprite_count].src = (*read_cache)(code << 9);
	sprite_info[sprite_count].dst = x + BUF_WIDTH * y;
	sprite_info[sprite_count].color = (attr & 0x1f) + 96;
	sprite_info[sprite_count].attr = attr & 0x60;
	++sprite_count;
}
