#include "cps2.h"

extern u16 *work_frame;

SPRITE sprite_info[MAX_SPRITE];
int sprite_count;

#define DRAW_8 tile = ~*gfx++;DRAW_1;DRAW_1;DRAW_1;DRAW_1;DRAW_1;DRAW_1;DRAW_1;DRAW_1
/*
#define DRAW_TILE_8 \
    DRAW_LINE;DRAW_NEXT;DRAW_LINE;DRAW_NEXT;DRAW_LINE;DRAW_NEXT;DRAW_LINE;DRAW_NEXT; \
    DRAW_LINE;DRAW_NEXT;DRAW_LINE;DRAW_NEXT;DRAW_LINE;DRAW_NEXT;DRAW_LINE
#define DRAW_TILE_16 DRAW_TILE_8;DRAW_NEXT;DRAW_TILE_8
#define DRAW_TILE_32 DRAW_TILE_16;DRAW_NEXT;DRAW_TILE_16
*/
#define DRAW_TILE \
    for(i=TILE_SIZE; i; --i) { DRAW_LINE;DRAW_NEXT; }

/*------------------------------------------------------------------------
	OBJECT꫹Ȫ
------------------------------------------------------------------------*/

void draw_screen(void)
{
	register u16 *dst, *pal;
	register u32 *gfx, tile;
	register int i;
	SPRITE *sprite = sprite_info;

	while (sprite->type != SPRITE_END) {
        int attr = sprite->attr;
		gfx = (u32 *)&memory_region_gfx1[sprite->src];
		dst = work_frame + sprite->dst;
		pal = &video_palette[sprite->color << 4];
		
		switch(sprite->type) {
            case SPRITE_8:
                #define DRAW_LINE ++gfx;DRAW_8;
//                #define DRAW_TILE DRAW_TILE_8
                #define TILE_SIZE 8
                if (attr & 0x20) {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; --dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1) + TILE_SIZE - 1;
                        #define DRAW_NEXT dst -= BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                		dst += TILE_SIZE - 1;
                        #define DRAW_NEXT dst += BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                } else {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; ++dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1);
                        #define DRAW_NEXT dst -= BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                        #define DRAW_NEXT dst += BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                }
                #undef TILE_SIZE
//                #undef DRAW_TILE
                #undef DRAW_LINE
                break;
            case SPRITE_16:
                #define DRAW_LINE DRAW_8;DRAW_8
//                #define DRAW_TILE DRAW_TILE_16
                #define TILE_SIZE 16
                if (attr & 0x20) {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; --dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1) + TILE_SIZE - 1;
                        #define DRAW_NEXT dst -= BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                		dst += TILE_SIZE - 1;
                        #define DRAW_NEXT dst += BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                } else {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; ++dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1);
                        #define DRAW_NEXT dst -= BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                        #define DRAW_NEXT dst += BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                }
                #undef TILE_SIZE
//                #undef DRAW_TILE
                #undef DRAW_LINE
                break;
            case SPRITE_32:
                #define DRAW_LINE DRAW_8;DRAW_8;DRAW_8;DRAW_8
//                #define DRAW_TILE DRAW_TILE_32
                #define TILE_SIZE 32
                if (attr & 0x20) {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; --dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1) + TILE_SIZE - 1;
                        #define DRAW_NEXT dst -= BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                		dst += TILE_SIZE - 1;
                        #define DRAW_NEXT dst += BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                } else {
                    #define DRAW_1 if(tile & 0x0f) *dst = pal[tile & 0x0f]; ++dst; tile >>= 4;
            		if (attr & 0x40) {
                		dst += BUF_WIDTH * (TILE_SIZE - 1);
                        #define DRAW_NEXT dst -= BUF_WIDTH + TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    } else {
                        #define DRAW_NEXT dst += BUF_WIDTH - TILE_SIZE;
               			DRAW_TILE;
               			#undef DRAW_NEXT
                    }
                    #undef DRAW_1
                }
                #undef TILE_SIZE
//                #undef DRAW_TILE
                #undef DRAW_LINE
                break;
        }
        
        ++sprite;
	}
}
