/******************************************************************************

	sndintrf.c

	ɫ󫿫ի

******************************************************************************/

#include "emumain.h"
#ifdef GP2X
#include <linux/soundcard.h>
#else
#include <SDL.h>
#endif

/******************************************************************************
	ɫ󫿫իμ
******************************************************************************/

/*------------------------------------------------------
	ɫ߫죭Ѣ
------------------------------------------------------*/
int sound_init(void)
{
	qsound_sh_start();

#ifndef GP2X
	SDL_AudioSpec spec;

	spec.format = AUDIO_S16;
	spec.channels = 2;
	spec.freq = 44100 >> (2 - option_samplerate);
	spec.samples = SOUND_SAMPLES >> (2 - option_samplerate);

	spec.callback = qsound_update;
	spec.userdata = NULL;

	if (SDL_OpenAudio(&spec, NULL) < 0) {
		printf("Unable to open audio: %s.\n", SDL_GetError());
		return 0;
	}

	SDL_PauseAudio(0);
#endif
	
	printf("Sound device initialized...\n");

	return 1;
}


/*------------------------------------------------------
	ɫ߫죭
------------------------------------------------------*/

void sound_exit(void)
{
	qsound_sh_stop();

#ifndef GP2X
	SDL_PauseAudio(1);
#endif
}


/*------------------------------------------------------
	ɫ߫죭꫻ë
------------------------------------------------------*/

void sound_reset(void)
{
#if (EMU_SYSTEM == CPS1)
	if (machine_sound_type == SOUND_QSOUND)
		qsound_sh_reset();
	else
		YM2151_sh_reset();
#elif (EMU_SYSTEM == CPS2)
	qsound_sh_reset();
#elif (EMU_SYSTEM == MVS)
	YM2610_sh_reset();
#endif

	sound_mute(0);
}


/*------------------------------------------------------
	ɫ߫壭
------------------------------------------------------*/

void sound_mute(int mute)
{
#ifndef GP2X
	if (mute)
    	SDL_PauseAudio(1);
	else
    	SDL_PauseAudio(!option_sound_enable);
#endif
}


void sound_volume(int volume)
{
#ifdef GP2X
    int mixer = open("/dev/mixer", O_RDWR);
    int vol;
    
    if(volume < 0) volume = 0;
    if(volume > 90) volume = 90;

    if(option_sound_volume != volume) {
        option_sound_volume = volume;

        if(mixer >= 0) {            
            vol = option_sound_volume | (option_sound_volume << 8);
        	ioctl(mixer, SOUND_MIXER_WRITE_PCM, &vol);
        	close(mixer);
        }
        
        if(option_sound_volume == 90) {
            msg_printf("Volume: Max\n");
        } else if(option_sound_volume == 0) {
            msg_printf("Volume: Off\n");
        } else {
            msg_printf("Volume: %d\n", option_sound_volume);
        }
    }
#endif
}
